Bug 2267127 - Review Request: libquicktime - Library for reading and writing Quicktime files
Summary: Review Request: libquicktime - Library for reading and writing Quicktime files
Keywords:
Status: ASSIGNED
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Benson Muite
QA Contact: Fedora Extras Quality Assurance
URL: http://libquicktime.sourceforge.net/
Whiteboard:
Depends On:
Blocks: MultimediaSIG
TreeView+ depends on / blocked
 
Reported: 2024-02-29 21:44 UTC by Dominik 'Rathann' Mierzejewski
Modified: 2024-03-03 21:24 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: ---
Embargoed:
benson_muite: fedora-review?


Attachments (Terms of Use)
The .spec file difference from Copr build 7092977 to 7094517 (976 bytes, patch)
2024-03-01 08:47 UTC, Fedora Review Service
no flags Details | Diff
The .spec file difference from Copr build 7094517 to 7095208 (2.12 KB, patch)
2024-03-01 14:46 UTC, Fedora Review Service
no flags Details | Diff
License listing from fedora-review (24.06 KB, text/plain)
2024-03-01 16:39 UTC, Benson Muite
no flags Details


Links
System ID Private Priority Status Summary Last Updated
RPM Fusion 6881 0 P1 NEW Review Request: libquicktime-freeworld - FAAD2, FFmpeg and x264 plugins for libquicktime library 2024-02-29 21:59:44 UTC

Description Dominik 'Rathann' Mierzejewski 2024-02-29 21:44:33 UTC
Spec URL: https://rathann.fedorapeople.org/review/libquicktime/libquicktime.spec
SRPM URL: https://rathann.fedorapeople.org/review/libquicktime/libquicktime-1.2.4-59.20240202git2213b76.fc39.src.rpm
Description:
Libquicktime is based on the quicktime4linux library with several
enhancements. All 3rd-party libraries were removed from the
sourcetree. Instead, the systemwide installed libraries are detected
by the configure script. All original codecs were moved into
dynamically loadable modules, and new codecs are in
development. Libquicktime is source-compatible with
quicktime4linux. Special API extensions allow access to the codec
registry and more convenient processing of Audio and Video
data.

Fedora Account System Username: rathann

Comment 1 Fedora Review Service 2024-02-29 21:47:36 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7092977
(failed)

Build log:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2267127-libquicktime/fedora-rawhide-x86_64/07092977-libquicktime/builder-live.log.gz

Please make sure the package builds successfully at least for Fedora Rawhide.

- If the build failed for unrelated reasons (e.g. temporary network
  unavailability), please ignore it.
- If the build failed because of missing BuildRequires, please make sure they
  are listed in the "Depends On" field


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 2 Dominik 'Rathann' Mierzejewski 2024-03-01 08:42:48 UTC
Spec URL: https://rathann.fedorapeople.org/review/libquicktime/libquicktime.spec
SRPM URL: https://rathann.fedorapeople.org/review/libquicktime/libquicktime-1.2.4-60.20240202git2213b76.fc41.src.rpm

* Fri Mar 01 2024 Dominik Mierzejewski <dominik> - 1.2.4-60.20240202git2213b76
- fix LAME detection

Comment 3 Fedora Review Service 2024-03-01 08:47:09 UTC
Created attachment 2019557 [details]
The .spec file difference from Copr build 7092977 to 7094517

Comment 4 Fedora Review Service 2024-03-01 08:47:11 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7094517
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2267127-libquicktime/fedora-rawhide-x86_64/07094517-libquicktime/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 5 Benson Muite 2024-03-01 14:13:39 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[-]: Provides: bundled(gnulib) in place as required.
     Note: Sources not installed
[x]: Package does not contain kernel modules.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GNU Lesser General Public License,
     Version 2.1", "FSF Unlimited License (with License Retention)", "*No
     copyright* GNU Library General Public License v2 or later [obsolete
     FSF postal address (Temple Place)]", "GNU Lesser General Public
     License v2.1 or later", "FSF Unlimited License (with License
     Retention) and/or GNU General Public License and/or GNU Lesser General
     Public License", "GNU General Public License". 73 files have unknown
     license. Detailed output of licensecheck in
     /home/fedora/2267127-libquicktime/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib64/pkgconfig, /usr/lib64/libquicktime
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib64/libquicktime
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[ ]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[ ]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[ ]: Package is not known to require an ExcludeArch tag.
[ ]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 3346 bytes in 2 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Sources can be downloaded from URI in Source: tag
     Note: Could not download Source0: https://sourceforge.net/code-
     snapshots/git/l/li/libquicktime/git.git/libquicktime-
     git-2213b76712c8e08d885482d117f904d570c990aa.zip
     See: https://docs.fedoraproject.org/en-US/packaging-
     guidelines/SourceURL/
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     libquicktime-utils
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[ ]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[!]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[!]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define date 20240202, %define
     commit 2213b76712c8e08d885482d117f904d570c990aa, %define shortcommit
     %(c=%{commit}; echo ${c:0:7})
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libquicktime-1.2.4-60.20240202git2213b76.fc41.aarch64.rpm
          libquicktime-utils-1.2.4-60.20240202git2213b76.fc41.aarch64.rpm
          libquicktime-devel-1.2.4-60.20240202git2213b76.fc41.aarch64.rpm
          libquicktime-debuginfo-1.2.4-60.20240202git2213b76.fc41.aarch64.rpm
          libquicktime-debugsource-1.2.4-60.20240202git2213b76.fc41.aarch64.rpm
          libquicktime-1.2.4-60.20240202git2213b76.fc41.src.rpm
====================================== rpmlint session starts ======================================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpy8wdi6ix')]
checks: 32, packages: 6

libquicktime.aarch64: E: spelling-error ('sourcetree', '%description -l en_US sourcetree -> source tree, source-tree, outsource')
libquicktime.aarch64: E: spelling-error ('systemwide', '%description -l en_US systemwide -> system wide, system-wide, systematize')
libquicktime.src: E: spelling-error ('sourcetree', '%description -l en_US sourcetree -> source tree, source-tree, outsource')
libquicktime.src: E: spelling-error ('systemwide', '%description -l en_US systemwide -> system wide, system-wide, systematize')
libquicktime-utils.aarch64: E: spelling-error ('commandline', '%description -l en_US commandline -> command line, command-line, commandment')
libquicktime-utils.aarch64: W: no-manual-page-for-binary libquicktime_config
libquicktime-utils.aarch64: W: no-manual-page-for-binary lqt_transcode
libquicktime-utils.aarch64: W: no-manual-page-for-binary lqtremux
libquicktime-utils.aarch64: W: no-manual-page-for-binary qt2text
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtdechunk
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtdump
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtinfo
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtrechunk
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtstreamize
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtyuv4toyuv
libquicktime.aarch64: E: incorrect-fsf-address /usr/share/licenses/libquicktime/COPYING
 6 packages and 0 specfiles checked; 6 errors, 10 warnings, 63 filtered, 6 badness; has taken 3.4 s 




Rpmlint (debuginfo)
-------------------
Checking: libquicktime-debuginfo-1.2.4-60.20240202git2213b76.fc41.aarch64.rpm
          libquicktime-utils-debuginfo-1.2.4-60.20240202git2213b76.fc41.aarch64.rpm
====================================== rpmlint session starts ======================================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmp93cw4m7a')]
checks: 32, packages: 2

 2 packages and 0 specfiles checked; 0 errors, 0 warnings, 51 filtered, 0 badness; has taken 1.3 s =





Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 6

libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_audiocodec.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_dv.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_dv.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_lame.so /lib64/libvorbis.so.0
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_lame.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_lame.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_mjpeg.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_mjpeg.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_png.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_png.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_rtjpeg.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_rtjpeg.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_schroedinger.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_schroedinger.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_videocodec.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_videocodec.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_vorbis.so /lib64/libvorbisfile.so.3
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_vorbis.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_vorbis.so /lib64/libz.so.1
libquicktime.aarch64: E: spelling-error ('sourcetree', '%description -l en_US sourcetree -> source tree, source-tree, outsource')
libquicktime.aarch64: E: spelling-error ('systemwide', '%description -l en_US systemwide -> system wide, system-wide, systematize')
libquicktime-utils.aarch64: E: spelling-error ('commandline', '%description -l en_US commandline -> command line, command-line, commandment')
libquicktime-utils.aarch64: W: no-manual-page-for-binary libquicktime_config
libquicktime-utils.aarch64: W: no-manual-page-for-binary lqt_transcode
libquicktime-utils.aarch64: W: no-manual-page-for-binary lqtremux
libquicktime-utils.aarch64: W: no-manual-page-for-binary qt2text
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtdechunk
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtdump
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtinfo
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtrechunk
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtstreamize
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtyuv4toyuv
libquicktime.aarch64: E: incorrect-fsf-address /usr/share/licenses/libquicktime/COPYING
 6 packages and 0 specfiles checked; 4 errors, 29 warnings, 103 filtered, 4 badness; has taken 7.0 s 



Unversioned so-files
--------------------
libquicktime: /usr/lib64/libquicktime/lqt_audiocodec.so
libquicktime: /usr/lib64/libquicktime/lqt_dv.so
libquicktime: /usr/lib64/libquicktime/lqt_lame.so
libquicktime: /usr/lib64/libquicktime/lqt_mjpeg.so
libquicktime: /usr/lib64/libquicktime/lqt_png.so
libquicktime: /usr/lib64/libquicktime/lqt_rtjpeg.so
libquicktime: /usr/lib64/libquicktime/lqt_schroedinger.so
libquicktime: /usr/lib64/libquicktime/lqt_videocodec.so
libquicktime: /usr/lib64/libquicktime/lqt_vorbis.so

Requires
--------
libquicktime (rpmlib, GLIBC filtered):
    ld-linux-aarch64.so.1()(64bit)
    libc.so.6()(64bit)
    libdv.so.4()(64bit)
    libjpeg.so.62()(64bit)
    libjpeg.so.62(LIBJPEG_6.2)(64bit)
    libm.so.6()(64bit)
    libmp3lame.so.0()(64bit)
    libpng16.so.16()(64bit)
    libpng16.so.16(PNG16_0)(64bit)
    libquicktime.so.0()(64bit)
    libschroedinger-1.0.so.0()(64bit)
    libvorbis.so.0()(64bit)
    libvorbisenc.so.2()(64bit)
    libvorbisfile.so.3()(64bit)
    libz.so.1()(64bit)
    rtld(GNU_HASH)

libquicktime-utils (rpmlib, GLIBC filtered):
    ld-linux-aarch64.so.1()(64bit)
    libGL.so.1()(64bit)
    libX11.so.6()(64bit)
    libXaw.so.7()(64bit)
    libXext.so.6()(64bit)
    libXt.so.6()(64bit)
    libXv.so.1()(64bit)
    libasound.so.2()(64bit)
    libasound.so.2(ALSA_0.9)(64bit)
    libasound.so.2(ALSA_0.9.0rc4)(64bit)
    libc.so.6()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgtk-x11-2.0.so.0()(64bit)
    libm.so.6()(64bit)
    libquicktime.so.0()(64bit)
    rtld(GNU_HASH)

libquicktime-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libquicktime(aarch-64)
    libquicktime.so.0()(64bit)
    zlib-devel

libquicktime-debuginfo (rpmlib, GLIBC filtered):

libquicktime-debugsource (rpmlib, GLIBC filtered):



Provides
--------
libquicktime:
    libquicktime
    libquicktime(aarch-64)
    libquicktime.so.0()(64bit)

libquicktime-utils:
    libquicktime-utils
    libquicktime-utils(aarch-64)

libquicktime-devel:
    libquicktime-devel
    libquicktime-devel(aarch-64)
    pkgconfig(libquicktime)

libquicktime-debuginfo:
    debuginfo(build-id)
    libquicktime-debuginfo
    libquicktime-debuginfo(aarch-64)
    libquicktime.so.0.0.0-1.2.4-60.20240202git2213b76.fc41.aarch64.debug()(64bit)

libquicktime-debugsource:
    libquicktime-debugsource
    libquicktime-debugsource(aarch-64)



Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/usr/bin/fedora-review -b 2267127
Buildroot used: fedora-rawhide-aarch64
Active plugins: C/C++, Shell-api, Generic
Disabled plugins: fonts, Python, Perl, R, Ocaml, Java, PHP, SugarActivity, Haskell
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH

Comments:

a) License in spec file should probably be
GPL-2.1-or-later AND LGPL-2.1-or-later 
not
GPL-2.1-or-later
Maybe also add an explanation in the spec file that some plugins are enabled, though the license
list produced
b) For the main package, perhaps add
%dir %{_libdir}/%{name}
to ensure directory ownership
c) Perhaps modify the spec file to have:
%global date 20240202
%global commit 2213b76712c8e08d885482d117f904d570c990aa
%global shortcommit %(c=%{commit}; echo ${c:0:7})
rather than
%define date 20240202
%define commit 2213b76712c8e08d885482d117f904d570c990aa
%define shortcommit %(c=%{commit}; echo ${c:0:7})
d) Does not build on s390x:
https://koji.fedoraproject.org/koji/taskinfo?taskID=114286515
perhaps exclude the architecture, some dependencies are unavailable
DEBUG util.py:461:  No match for argument: libavc1394-devel
DEBUG util.py:461:  No match for argument: libraw1394-devel
e) Should the util package explicitly require the libquicktime package to ensure license is always installed?
f) Should lqtplay have a desktop file?

Comment 6 Dominik 'Rathann' Mierzejewski 2024-03-01 14:40:05 UTC
(In reply to Benson Muite from comment #5)
[...]
> Comments:
> 
> a) License in spec file should probably be
> GPL-2.1-or-later AND LGPL-2.1-or-later 
> not
> GPL-2.1-or-later
> Maybe also add an explanation in the spec file that some plugins are
> enabled, though the license
> list produced

End of the sentence missing? Otherwise not sure what you mean above.

> b) For the main package, perhaps add
> %dir %{_libdir}/%{name}
> to ensure directory ownership

Sure.

> c) Perhaps modify the spec file to have:
> %global date 20240202
> %global commit 2213b76712c8e08d885482d117f904d570c990aa
> %global shortcommit %(c=%{commit}; echo ${c:0:7})
> rather than
> %define date 20240202
> %define commit 2213b76712c8e08d885482d117f904d570c990aa
> %define shortcommit %(c=%{commit}; echo ${c:0:7})

Ok.

> d) Does not build on s390x:
> https://koji.fedoraproject.org/koji/taskinfo?taskID=114286515
> perhaps exclude the architecture, some dependencies are unavailable
> DEBUG util.py:461:  No match for argument: libavc1394-devel
> DEBUG util.py:461:  No match for argument: libraw1394-devel

Fixed.

> e) Should the util package explicitly require the libquicktime package to
> ensure license is always installed?

Added, but it'll always pull in libquicktime as a dependency, anyway.

> f) Should lqtplay have a desktop file?

Perhaps.

Spec URL: https://rathann.fedorapeople.org/review/libquicktime/libquicktime.spec
SRPM URL: https://rathann.fedorapeople.org/review/libquicktime/libquicktime-1.2.4-61.20240202git2213b76.fc41.src.rpm

* Fri Mar 01 2024 Dominik Mierzejewski <dominik> - 1.2.4-61.20240202git2213b76
- drop missing lib{avc,raw}1394 build dependencies on s390x
- add LGPLv2.1 to License field
- own _libdir/libquicktime
- use global instead of define

Comment 7 Fedora Review Service 2024-03-01 14:46:23 UTC
Created attachment 2019597 [details]
The .spec file difference from Copr build 7094517 to 7095208

Comment 8 Fedora Review Service 2024-03-01 14:46:25 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7095208
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2267127-libquicktime/fedora-rawhide-x86_64/07095208-libquicktime/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 9 Benson Muite 2024-03-01 16:37:13 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[-]: Provides: bundled(gnulib) in place as required.
     Note: Sources not installed
[x]: Package does not contain kernel modules.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GNU Lesser General Public License,
     Version 2.1", "FSF Unlimited License (with License Retention)", "*No
     copyright* GNU Library General Public License v2 or later [obsolete
     FSF postal address (Temple Place)]", "GNU Lesser General Public
     License v2.1 or later", "FSF Unlimited License (with License
     Retention) and/or GNU General Public License and/or GNU Lesser General
     Public License", "GNU General Public License". 73 files have unknown
     license. Detailed output of licensecheck in
     /home/fedora/2267127-libquicktime/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[ ]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[ ]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib64/pkgconfig
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[ ]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[ ]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 3346 bytes in 2 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Sources can be downloaded from URI in Source: tag
     Note: Could not download Source0: https://sourceforge.net/code-
     snapshots/git/l/li/libquicktime/git.git/libquicktime-
     git-2213b76712c8e08d885482d117f904d570c990aa.zip
     See: https://docs.fedoraproject.org/en-US/packaging-
     guidelines/SourceURL/
[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libquicktime-1.2.4-61.20240202git2213b76.fc41.aarch64.rpm
          libquicktime-utils-1.2.4-61.20240202git2213b76.fc41.aarch64.rpm
          libquicktime-devel-1.2.4-61.20240202git2213b76.fc41.aarch64.rpm
          libquicktime-debuginfo-1.2.4-61.20240202git2213b76.fc41.aarch64.rpm
          libquicktime-debugsource-1.2.4-61.20240202git2213b76.fc41.aarch64.rpm
          libquicktime-1.2.4-61.20240202git2213b76.fc41.src.rpm
====================================== rpmlint session starts ======================================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmp9wpdgofh')]
checks: 32, packages: 6

libquicktime.aarch64: E: spelling-error ('sourcetree', '%description -l en_US sourcetree -> source tree, source-tree, outsource')
libquicktime.aarch64: E: spelling-error ('systemwide', '%description -l en_US systemwide -> system wide, system-wide, systematize')
libquicktime.src: E: spelling-error ('sourcetree', '%description -l en_US sourcetree -> source tree, source-tree, outsource')
libquicktime.src: E: spelling-error ('systemwide', '%description -l en_US systemwide -> system wide, system-wide, systematize')
libquicktime-utils.aarch64: E: spelling-error ('commandline', '%description -l en_US commandline -> command line, command-line, commandment')
libquicktime-utils.aarch64: W: no-manual-page-for-binary libquicktime_config
libquicktime-utils.aarch64: W: no-manual-page-for-binary lqt_transcode
libquicktime-utils.aarch64: W: no-manual-page-for-binary lqtremux
libquicktime-utils.aarch64: W: no-manual-page-for-binary qt2text
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtdechunk
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtdump
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtinfo
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtrechunk
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtstreamize
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtyuv4toyuv
libquicktime.aarch64: E: incorrect-fsf-address /usr/share/licenses/libquicktime/COPYING
 6 packages and 0 specfiles checked; 6 errors, 10 warnings, 63 filtered, 6 badness; has taken 3.4 s 




Rpmlint (debuginfo)
-------------------
Checking: libquicktime-debuginfo-1.2.4-61.20240202git2213b76.fc41.aarch64.rpm
          libquicktime-utils-debuginfo-1.2.4-61.20240202git2213b76.fc41.aarch64.rpm
====================================== rpmlint session starts ======================================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpc384q825')]
checks: 32, packages: 2

 2 packages and 0 specfiles checked; 0 errors, 0 warnings, 51 filtered, 0 badness; has taken 1.3 s =





Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 6

libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_audiocodec.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_dv.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_dv.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_lame.so /lib64/libvorbis.so.0
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_lame.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_lame.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_mjpeg.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_mjpeg.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_png.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_png.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_rtjpeg.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_rtjpeg.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_schroedinger.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_schroedinger.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_videocodec.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_videocodec.so /lib64/libz.so.1
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_vorbis.so /lib64/libvorbisfile.so.3
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_vorbis.so /lib64/libm.so.6
libquicktime.aarch64: W: unused-direct-shlib-dependency /usr/lib64/libquicktime/lqt_vorbis.so /lib64/libz.so.1
libquicktime.aarch64: E: spelling-error ('sourcetree', '%description -l en_US sourcetree -> source tree, source-tree, outsource')
libquicktime.aarch64: E: spelling-error ('systemwide', '%description -l en_US systemwide -> system wide, system-wide, systematize')
libquicktime-utils.aarch64: E: spelling-error ('commandline', '%description -l en_US commandline -> command line, command-line, commandment')
libquicktime-utils.aarch64: W: no-manual-page-for-binary libquicktime_config
libquicktime-utils.aarch64: W: no-manual-page-for-binary lqt_transcode
libquicktime-utils.aarch64: W: no-manual-page-for-binary lqtremux
libquicktime-utils.aarch64: W: no-manual-page-for-binary qt2text
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtdechunk
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtdump
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtinfo
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtrechunk
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtstreamize
libquicktime-utils.aarch64: W: no-manual-page-for-binary qtyuv4toyuv
libquicktime.aarch64: E: incorrect-fsf-address /usr/share/licenses/libquicktime/COPYING
 6 packages and 0 specfiles checked; 4 errors, 29 warnings, 104 filtered, 4 badness; has taken 7.2 s 



Unversioned so-files
--------------------
libquicktime: /usr/lib64/libquicktime/lqt_audiocodec.so
libquicktime: /usr/lib64/libquicktime/lqt_dv.so
libquicktime: /usr/lib64/libquicktime/lqt_lame.so
libquicktime: /usr/lib64/libquicktime/lqt_mjpeg.so
libquicktime: /usr/lib64/libquicktime/lqt_png.so
libquicktime: /usr/lib64/libquicktime/lqt_rtjpeg.so
libquicktime: /usr/lib64/libquicktime/lqt_schroedinger.so
libquicktime: /usr/lib64/libquicktime/lqt_videocodec.so
libquicktime: /usr/lib64/libquicktime/lqt_vorbis.so

Requires
--------
libquicktime (rpmlib, GLIBC filtered):
    ld-linux-aarch64.so.1()(64bit)
    libc.so.6()(64bit)
    libdv.so.4()(64bit)
    libjpeg.so.62()(64bit)
    libjpeg.so.62(LIBJPEG_6.2)(64bit)
    libm.so.6()(64bit)
    libmp3lame.so.0()(64bit)
    libpng16.so.16()(64bit)
    libpng16.so.16(PNG16_0)(64bit)
    libquicktime.so.0()(64bit)
    libschroedinger-1.0.so.0()(64bit)
    libvorbis.so.0()(64bit)
    libvorbisenc.so.2()(64bit)
    libvorbisfile.so.3()(64bit)
    libz.so.1()(64bit)
    rtld(GNU_HASH)

libquicktime-utils (rpmlib, GLIBC filtered):
    ld-linux-aarch64.so.1()(64bit)
    libGL.so.1()(64bit)
    libX11.so.6()(64bit)
    libXaw.so.7()(64bit)
    libXext.so.6()(64bit)
    libXt.so.6()(64bit)
    libXv.so.1()(64bit)
    libasound.so.2()(64bit)
    libasound.so.2(ALSA_0.9)(64bit)
    libasound.so.2(ALSA_0.9.0rc4)(64bit)
    libc.so.6()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgtk-x11-2.0.so.0()(64bit)
    libm.so.6()(64bit)
    libquicktime(aarch-64)
    libquicktime.so.0()(64bit)
    rtld(GNU_HASH)

libquicktime-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libquicktime(aarch-64)
    libquicktime.so.0()(64bit)
    zlib-devel

libquicktime-debuginfo (rpmlib, GLIBC filtered):

libquicktime-debugsource (rpmlib, GLIBC filtered):



Provides
--------
libquicktime:
    libquicktime
    libquicktime(aarch-64)
    libquicktime.so.0()(64bit)

libquicktime-utils:
    libquicktime-utils
    libquicktime-utils(aarch-64)

libquicktime-devel:
    libquicktime-devel
    libquicktime-devel(aarch-64)
    pkgconfig(libquicktime)

libquicktime-debuginfo:
    debuginfo(build-id)
    libquicktime-debuginfo
    libquicktime-debuginfo(aarch-64)
    libquicktime.so.0.0.0-1.2.4-61.20240202git2213b76.fc41.aarch64.debug()(64bit)

libquicktime-debugsource:
    libquicktime-debugsource
    libquicktime-debugsource(aarch-64)



Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/usr/bin/fedora-review -b 2267127
Buildroot used: fedora-rawhide-aarch64
Active plugins: Shell-api, Generic, C/C++
Disabled plugins: R, PHP, Python, fonts, Java, Haskell, Ocaml, Perl, SugarActivity
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH

Comments:

>> a) License in spec file should probably be
>> GPL-2.1-or-later AND LGPL-2.1-or-later 
>> not
>> GPL-2.1-or-later
>> Maybe also add an explanation in the spec file that some plugins are
>> enabled, though the license
>> list produced

> End of the sentence missing? Otherwise not sure what you mean above.

Sorry, the license listing does not indicate any GPL files for anythin other
than m4 files used during the build process. Nevertheless,
it may be helpful to add an explanation in the spec file that the GPL
license is due to enabling a configuration for this.  Probably upstream
should also add GPL license file to the source archive.

b) Building the documentation may be helpful.  If built as html, would suggest a separate package due to the
use of jquery and javascript.  Doxygen can also generate output in other formats, but unclear if it would be
helpful.  Not a must to build the documentation though.

c) lqtplay is a graphical application, so probably a desktop file is helpful, though unclear what qualifies
as a GUI application.

Comment 10 Benson Muite 2024-03-01 16:39:02 UTC
Created attachment 2019601 [details]
License listing from fedora-review

Comment 11 Dominik 'Rathann' Mierzejewski 2024-03-03 21:24:24 UTC
(In reply to Benson Muite from comment #9)
[...]
> Comments:
> 
> >> a) License in spec file should probably be
> >> GPL-2.1-or-later AND LGPL-2.1-or-later 
> >> not
> >> GPL-2.1-or-later
> >> Maybe also add an explanation in the spec file that some plugins are
> >> enabled, though the license
> >> list produced
> 
> > End of the sentence missing? Otherwise not sure what you mean above.
> 
> Sorry, the license listing does not indicate any GPL files for anythin other
> than m4 files used during the build process. Nevertheless,
> it may be helpful to add an explanation in the spec file that the GPL
> license is due to enabling a configuration for this.  Probably upstream
> should also add GPL license file to the source archive.

I see what you mean. GPL license is enabled by the --enable-gpl switch,
which is necessary to allow externally-built GPL plugins to work.

> b) Building the documentation may be helpful.  If built as html, would
> suggest a separate package due to the
> use of jquery and javascript.  Doxygen can also generate output in other
> formats, but unclear if it would be
> helpful.  Not a must to build the documentation though.

Given how old this code is, I think it's not worth the effort.

> c) lqtplay is a graphical application, so probably a desktop file is
> helpful, though unclear what qualifies
> as a GUI application.

It's a video player with very limited capabilities (only X11 with Xvideo
or OpenGL and ALSA outputs). I think it's not advisable to make it easily
discoverable.


Note You need to log in before you can comment on or make changes to this bug.